<html>
<head>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
<script type="text/javascript" src="jquery-1.10.2.js"></script>
<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
<script type="text/javascript" src="calculationlib/polynomial.js"></script>
<script type="text/javascript" src="calculationlib/mathhelper.js"></script>

<style>
.edit-text {
  display: none;
}
.label-g .mathtex {
  float: left;
}
.mathtex {
  padding: 5px;
}
td {
  padding: 5px;
}
</style>

<style>
  .thumb {
   /* height: 75px;
    border: 1px solid #000;
    margin: 10px 5px 0 0; */
  }
</style>

</head>
<body>

  <div>
    <div style="float:left"><input type="file" id="files" name="files[]" multiple /> </div>
    <div style="float:left" id="list"></div>
  </div>
  <div> <input type="button" id="btnTranspose" value="Transpoz">
  <div id="result"  style="padding: 20px"> </div>

<!--  <div>
    <input type="button" id="makeGray" value="Convert To Grayscale" />
    \(grayscale = 0.2989 \cdot R + 0.5870 \cdot G + 0.1140 \cdot B \)
  </div>

  <div id="result2"  style="padding: 20px"> </div>
-->

  <script>
  var result = $("#result");
  var result2 = $("#result2");

  var mthhlp = new mathhelper();
  var redMatrix;
  var greenMatrix;
  var blueMatrix;
  var grayMatrix;

  var CreateImage = function(matrix){
    var width = matrix.ColCount,
        height = matrix.RowCount,
        buffer = new Uint8ClampedArray(width * height * 4); // have enough bytes

    for(var y = 0; y < height; y++) {
      for(var x = 0; x < width; x++) {
        var pos = (y * width + x) * 4; // position in buffer based on x and y
        var val = matrix.Get(y, x);
        buffer[pos  ] = val;           // some R value [0, 255]
        buffer[pos+1] = val;           // some G value
        buffer[pos+2] = val;           // some B value
        buffer[pos+3] = 255;           // set alpha channel
      }
    }
    //var canvas = $('<canvas/>');
    var canvas = document.createElement('canvas'),
    ctx = canvas.getContext('2d');
    canvas.width = width;
    canvas.height = height;
    var idata = ctx.createImageData(width, height); // create imageData object
    idata.data.set(buffer);        // set our buffer as source
    ctx.putImageData(idata, 0, 0); // update canvas with new data
    return canvas;
  }
  var Copy = function(text) {
    var copyFrom = $('<textarea/>');
    copyFrom.css({
     position: "absolute",
     left: "-1000px",
     top: "-1000px",
    });
     copyFrom.text(text);
     $('body').append(copyFrom);
     copyFrom.select();
     document.execCommand('copy');
  }

var dataMatrix;

$(document).ready(function() {
    function handleFileSelect(evt) {
      var files = evt.target.files; // FileList object

      // //var canvas = document.getElementById('canvas');
       var canvas = document.createElement('canvas');
       canvas.id = "image";
       $("#list").html("");
       $("#list").append(canvas);
       ctx = canvas.getContext('2d');

      for (var i = 0, f; f = files[i]; i++) {
        if (!f.type.match('image.*')) {
          continue;
        }

        var reader = new FileReader();
        reader.onload = function (e) {
            var data = e.target.result;
            var array = Array.from(new Uint8Array(data));
            dataMatrix = new Matrix([ array ]);

            mthhlp.out.clear(result);
            mthhlp.out.write(result, "BOYUTU = " + array.length);
            mthhlp.out.write(result, "");
            mthhlp.out.write(result, "DATA = " + dataMatrix.ToLatex());

        };
        reader.readAsArrayBuffer(f);
        continue;

        reader.onload = (function(theFile) {
          return function(e) {
            //var span = document.createElement('span');
            //span.innerHTML = ['<img id="my-image" class="thumb" src="', e.target.result, '" title="', escape(theFile.name), '"/>'].join('');
            //document.getElementById('list').insertBefore(span, null);
            var img = new Image();
            img.onload = function() {
              canvas.width = img.width;
              canvas.height = img.height;
              ctx.drawImage(img,0,0);
              var data = ctx.getImageData(0, 0, img.width, img.height);
              console.log(data);

              var red   = Array(img.height).fill(0).map((x,i) => Array(img.width).fill(0).map((y,j) => data.data[i * img.width * 4 + j * 4]));
              var green = Array(img.height).fill(0).map((x,i) => Array(img.width).fill(0).map((y,j) => data.data[i * img.width * 4 + j * 4 + 1]));
              var blue  = Array(img.height).fill(0).map((x,i) => Array(img.width).fill(0).map((y,j) => data.data[i * img.width * 4 + j * 4 + 2]));
              redMatrix = new Matrix(red);
              greenMatrix = new Matrix(green);
              blueMatrix = new Matrix(blue);



              mthhlp.out.clear(result);
              mthhlp.out.write(result, "R = " + redMatrix.ToLatex());
              var canvasRed = CreateImage(redMatrix);
              result.append(canvasRed);
              result.append($("<input style='margin: 5' type='button' value='Kopyala' onclick='Copy(redMatrix.ToString2())'/>"));
              mthhlp.out.write(result, "");

              mthhlp.out.write(result, "G = " + greenMatrix.ToLatex());
              var canvasGreen = CreateImage(greenMatrix);
              result.append(canvasGreen);
              result.append($("<input style='margin: 5' type='button' value='Kopyala' onclick='Copy(greenMatrix.ToString2())'/>"));
              mthhlp.out.write(result, "");

              mthhlp.out.write(result, "B = " + blueMatrix.ToLatex());
              var canvasBlue = CreateImage(blueMatrix);
              result.append(canvasBlue);
              result.append($("<input style='margin: 5' type='button' value='Kopyala' onclick='Copy(blueMatrix.ToString2())'/>"));
              mthhlp.out.write(result, "");
            };
            img.src = e.target.result;
          };
        })(f);
        reader.readAsDataURL(f);
      }
    }


    document.getElementById('files').addEventListener('change', handleFileSelect);

    $('#makeGray').on('click', function(e) {
        //gray = 0.2989 * rgb(:,:,1) + 0.5870 * rgb(:,:,2) + 0.1140 * rgb(:,:,3);
        var calc = new MatrixCalculator();
        var r = calc.Multiply(redMatrix, 0.2989);
        var g = calc.Multiply(greenMatrix, 0.5870);
        var b = calc.Multiply(blueMatrix, 0.1140);
        grayMatrix = calc.Add(r, g);
        grayMatrix = calc.Add(grayMatrix, b).ToInt();


        mthhlp.out.clear(result2);
        mthhlp.out.write(result2, "Grayscale = " + grayMatrix.ToLatex());

        var canvasGray = CreateImage(grayMatrix);
        result2.append(canvasGray);
        result2.append($("<input style='margin: 5' type='button' value='Kopyala' onclick='Copy(grayMatrix.ToString2())'/>"));


    });
    $('#btnTranspose').on('click', function(e) {

      if (!dataMatrix)
        return;

        dataMatrix = dataMatrix.Transpose();
        mthhlp.out.clear(result);
        mthhlp.out.write(result, "BOYUTU = " + dataMatrix.RowCount);
        mthhlp.out.write(result, "");
        mthhlp.out.write(result, "DATA = " + dataMatrix.ToLatex());


    });
});
  </script>


</body>
</html>
